from twython import TwythonStreamer
import time, sys, fileinput

APP_KEY = '...'
APP_SECRET = '...'
OAUTH_TOKEN = '...'
OAUTH_TOKEN_SECRET = '...'

ROOT_DIR = "."

queries = ["happy holidays", "merry christmas", "happy new year"]

class SomeStreamer(TwythonStreamer):
    
    start_time = time.time()
    sample_min = 2
    sample_sec = sample_min * 60
    tweet_count = 0
    total_sec = 0
    def on_success(self, data):
        if 'text' in data:
            # print data['text'].encode('utf-8')
            self.tweet_count += 1
            elapsed_time = time.time() - self.start_time
            if elapsed_time >= self.sample_sec:
                self.total_sec = elapsed_time
                self.disconnect()
    def reset(self):
        self.start_time = time.time()
        self.tweet_count = 0
        self.total_sec = 0
        
    # def on_error(self, status_code, data):
    #     print status_code

        # Want to stop trying to get data because of the error?
        # Uncomment the next line!
        # self.disconnect()

rates = []
stream = SomeStreamer(APP_KEY, APP_SECRET,
                    OAUTH_TOKEN, OAUTH_TOKEN_SECRET)
for i in range(0, len(queries)):
    stream.reset()
    stream.statuses.filter(track=queries[i])
    tweets_per_min = round(stream.tweet_count / stream.total_sec * 60, 5)
    rates.append(tweets_per_min)
    print queries[i] + "\t" + str(stream.start_time) + "\t" + str(tweets_per_min)

# Write current rates to file.
f = open(ROOT_DIR + "/current-rates.txt", "w")
f.write("<rates>")
for r in rates:
    f.write("%s " % r)
f.write("</rates>")
f.close()


    